image: google/cloud-sdk:latest

stages:
  - build-image

variables:
  GOOGLE_APPLICATION_CREDENTIALS: $GCP_KEY
  PROJECT_ID: $PROJECT_ID
  ENV: $ENV
  DOCKER_IMAGE_TAG: v0.1
  DOCKER_IMAGE_PREFIX: $LOCATION-docker.pkg.dev/$PROJECT_ID/$ARTIFACT_REPOSITORY
  DOCKER_IMAGE_NAME: data.transformation.repo
  CI_REPO_TOKEN: $CI_REPO_TOKEN

build_prod:
  stage: build-image
  environment: prod
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
      changes:
        - dbt/olist_bi/models/**/*
        - Dockerfile
  script:
    - export DOCKER_IMAGE_FULL_PATH="$DOCKER_IMAGE_PREFIX/$DOCKER_IMAGE_NAME:$DOCKER_IMAGE_TAG"
    - gcloud auth activate-service-account --key-file=$GOOGLE_APPLICATION_CREDENTIALS
    - gcloud config set project $PROJECT_ID
    - export CI_REPO_TOKEN_DECODED=$(echo "$CI_REPO_TOKEN" | base64 -d)
    - sh set_vars.sh
    - gcloud builds submit --tag $DOCKER_IMAGE_FULL_PATH ./